﻿// ★今回は気にしない (usingディレクティブ)★
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// ★今回は気にしない (public class)★
public class Sharp1No1 : MonoBehaviour
{
    // コメント

    /*
       複数行の
       コメント
    */

    // <sumary>などとxmlタグで書かれているものはキュメントコメント
    // クラスやメソッドの上で /// と打つと挿入される

    /// <summary>
    /// プレイすると1回だけ実行されるメソッド
    /// </summary>
    void Start()
    {
        // ---------- int型の変数を使う ----------

        // int は整数を扱えるデータ型
        int i1 = 10;
        int i2 = 2;

        int i3 = i1 + i2;   // 加算 (10 + 2)
        int i4 = i1 - i2;   // 減算 (10 - 2)
        int i5 = i1 * i2;   // 乗算 (10 * 2)
        int i6 = i1 / i2;   // 除算 (10 / 2)
        int i7 = i1 % i2;   // 剰余 (10 / 2 の余り)

        i1 += 10;   // i1 = i1 + 10 と同じ

        i1++;   // i1 += 1 と同じ (インクリメント)
        ++i1;

        i1--;   // i1 -= 1 と同じ (デクリメント)
        --i1;


        // ---------- メソッドを実行してみる ----------

        Scope(); // ステップインしてみよう

        Scope(); // ステップオーバーしてみよう (Scope()の中に入らないで進む)

        Scope(); // ステップインした後に、Scope()の中でステップアウトしてみよう


        // ---------- 戻り値があるメソッドを実行してみる ----------

        int code = GetCode();  // GetCode() の return値を受け取る
        GetCode();             // 必ず受け取る必要はない


        // ---------- 引数のあるメソッドを実行してみる ----------

        int add = Add10(i1);          // i1 をAdd10の引数に渡す
        int sub = Subtract(100, i1);  // 100(←リテラル)でも、i1(←変数)でもOK


        // ---------- 計算した結果を使ってみる ----------

        // ★今回は気にしない (transform)★

        // 指定した距離を移動
        transform.Translate(i3, i4, i5 - i6 + i7);

        // i5 - i6 + i7 は見にくいので
        // 計算が必要な z を変数にして見やすくする
        int z = i5 - i6 + i7;

        transform.Translate(i3, i4, z);

        // 改行しても見やすい
        transform.Translate(
            i3,
            i4,
            i5 - i6 + i7);
    }

    /// <summary>
    /// void Scope() の void は戻り値がないメソッドという意味
    /// </summary>
    void Scope()
    {
        bool b = true;

        // { }が1つのブロック
        {
            // i2はブロック内でのみ有効
            int i2 = 20;

            b = i2 == 20;
        }

        // 同じ i2 だけど、{ }ブロックが違うので別物
        {
            int i2 = 30;

            b = i2 == 30;
        }

        // Scope() 内で有効な i1 を定義
        int i1 = 1;

        {
            // 親のブロックで i1 が定義済みなので、
            // このブロックで i1 定義できない

            // 下記コメントを外すとコンパイルエラー
            //int i1 = 10;

            // 定義済みの i1 を使うのはOK
            i1 = 10;
        }

        // return でこのメソッドを終了する (b = i1 == 10 が実行されない)
        return;

        // 上の return; をコメントして、再実行してみよう
        // (b = i1 == 10 が実行される)

        // 未使用の変数があると、UnityのConsoleに警告される
        // 本開発では警告が無くなるように修正すること！
        b = i1 == 10;
    }

    /// <summary>
    /// int GetCode() の int は戻り値にintを返すという意味
    /// </summary>
    int GetCode()
    {
        // この i1 はGetCode()内でのみ有効
        // さっきの(void Start()の中の) i1 とは別物
        int i1 = 999;

        return i1;
    }

    /// <summary>
    /// 引数valueに10を足して返す
    /// </summary>
    /// <param name="value">この値に10を足すよ</param>
    /// <returns><see cref="value"/>に10を足して返す</returns>
    int Add10(int value)
    {
        // 1度変数 add に入れると、デバッグしやすい
        // (ステップインすると、return する前に add の中身が見える)
        int add = value + 10;

        return add;
    }

    /// <summary>
    /// 引数value1 - value2 の結果を返す
    /// </summary>
    int Subtract(int value1, int value2)
    {
        // 変数に入れずに返すことも可能
        return value1 - value2;
    }
}