﻿/*
 今回の目的

 ● 開発環境を準備してデバッグする！
 ● メソッドを書いて実行する！
 ● 変数で int(整数型) と bool(論理型) を使う！
 ● if で条件判定する！
 ● for で繰り返し(ループ)処理する！
 */

// ★今回は気にしない (usingディレクティブ)★
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// ★今回は気にしない (public class)★
public class Sharp1 : MonoBehaviour
{
    // コメント

    /*
       複数行の
       コメント
    */

    // <sumary>などとxmlタグで書かれているものはキュメントコメント
    // クラスやメソッドの上で /// と打つと挿入される

    /// <summary>
    /// プレイすると1回だけ実行されるメソッド
    /// </summary>
    void Start()
    {
        No1();
        No2();
    }

    #region ********** No1 **********

    /// <summary>
    /// void は戻り値がないメソッドという意味
    /// </summary>
    void No1()
    {
        // int は整数を扱えるデータ型
        int i1 = 10;
        int i2 = 2;

        int i3 = i1 + i2;   // 加算 (10 + 2)
        int i4 = i1 - i2;   // 減算 (10 - 2)
        int i5 = i1 * i2;   // 乗算 (10 * 2)
        int i6 = i1 / i2;   // 除算 (10 / 2)
        int i7 = i1 % i2;   // 剰余 (10 / 2 の余り)

        i1 += 10;   // i1 = i1 + 10 と同じ

        i1++;   // i1 += 1 と同じ (インクリメント)
        ++i1;

        i1--;   // i1 -= 1 と同じ (デクリメント)
        --i1;

        {
            int x = i3 + i4 + i5 + i6 + i7;
            Log(x);
        }
        {
            // ↑のxとは別物
            // { } が1つのブロックで、変数のスコープが異なる
            int x = i3 + i4 + i5 + i6 + i7;
            Add(x, 0);
        }
    }

    /// <summary>
    /// void Scope() の void は戻り値がないメソッドという意味
    /// </summary>
    void Log(int value)
    {
        Dummy.Log(value);
    }

    /// <summary>
    /// 引数value1 + value2 の結果を返す。
    /// </summary>
    int Add(int value1, int value2)
    {
        return value1 + value2;
    }

    #endregion

    #region ********** No2 **********

    void No2()
    {
        If();
        ConditionalOperator();
        For();
    }

    void If()
    {
        // boolは論理値 (true か false)
        int i = 10;
        bool b = i == 10;

        // if() にはboolを渡せば良い
        if (b && i == 10 || Is10(i))
        {
            // if (b)       → bool型を渡してもOK
            // if (i == 10) → 演算結果がboolになるなら渡してもOK
            // if (Is10(i)) → メソッドの戻り値がboolなら渡してもOK
        }
        else
        {
            // ショートサーキット (短絡評価)

            // && || で複数条件にできる (判定順序は && の後に ||)
            // この if文では、 Is10(i) メソッドは実行されない
        }
    }

    bool Is10(int i)
    {
        return i == 10;
    }

    /// <summary>
    /// 三項演算子
    /// </summary>
    void ConditionalOperator()
    {
        // const をつけると定数として宣言される
        const int hp = 5;

        // 書き換え不能 (以下のコメントを外すと、コンパイルエラー)
        //hp = 16;

        int damage = hp <= 10 ? 150 : 100;

        Dummy.Log(damage);
    }

    /// <summary>
    /// 二重ループ
    /// </summary>
    void For()
    {
        // const をつけると定数として宣言される
        const int answer = 16;

        // 書き換え不能 (以下のコメントを外すと、コンパイルエラー)
        //answer = 16;

        // 二重ループ
        for (int i = 1; i <= 9; i++)
        {
            for (int j = 1; j <= 9; j++)
            {
                if (j == 5)
                {
                    // 次の jループに進む
                    continue;
                }

                // 九九で答えが 16 になったら終了
                if (i * j == answer)
                {
                    // jのループを抜けるだけ
                    break;
                }

                if (i * j >= 40)
                {
                    // For2()メソッド自体が終了する
                    return;
                }
            }
        }

        // returnだとここに到達しない
    }

    #endregion
}