﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Sharp2 : MonoBehaviour
{
    void Start()
    {
        String();

        string[] array = Array();

        ForEach(array);
    }

    /// <summary>
    /// 文字列を使う
    /// </summary>
    void String()
    {
        // ********** 定義 **********

        string s1 = "文字です";

        // "私は文字です" に連結される
        s1 = "私は" + s1;

        // "私は文字ですよ！" に連結される (intと同じように += が使える)
        s1 += "よ！";

        // 文字数
        var len = s1.Length;


        // ********** Unityの世界に向けて使ってみる **********

        name = s1;

        gameObject.name = s1;  // どちらも結果は同じ


        // ********** クリア **********

        // 空文字を入れる、つまり文字数は0
        s1 = "";
        s1 = string.Empty;

        len = s1.Length;

        // null は特殊 (文字列ではなく参照先をなくす！？)
        s1 = null;

        // 文字数を取得しようとすると、実行時に例外が発生する
        // len = s1.Length;

        Dummy.Log(len);

        // ********** 判定 **********

        // null と 空文字 の両方で判定する必要がある
        var isNullOrEmpty = s1 == null || s1 == "";

        // このメソッドを使えば判定できる
        isNullOrEmpty = string.IsNullOrEmpty(s1);

        Dummy.Log(isNullOrEmpty);

        // ********** null 条件演算子 **********

        s1 = "1234567";

        // s1 が null だと例外が発生する点に注意！
        if (s1.Length > 5)
        {
            // 5文字を超えたら先頭の5文字だけにする
            s1 = s1.Substring(0, 5);
        }

        s1 = Null();

        // null 条件演算子 (C# 6) ならnull判定が不要
        if (s1?.Length > 5)
        {
            // if (s1 != null && s1.Length > 5) と同じ

            s1 = s1.Substring(0, 5);
        }


        // ********** やりたい操作があった時に調べればOK！ **********

        s1 = "1234567";

        // 判定する

        s1.Contains("この文字が含まれているか");
        s1.StartsWith("この文字から始まるか");
        s1.EndsWith("この文字で終わるか");

        s1.IndexOf("この文字の位置はどこか (先頭から探す)");
        s1.LastIndexOf("この文字の位置はどこか (末尾から探す)");

        // 操作する

        s1.Trim();     // 先頭末尾のスペースや改行を削除
        s1.PadLeft(10);     // 10文字になるように先頭にスペース挿入
        s1.PadRight(10);    // 10文字になるように末尾にスペース挿入

        s1.Substring(2, 4);                   // 3文字目から2文字を抽出
        s1.Remove(2);                         // 3文字目以降を削除
        s1.Insert(0, "先頭に挿入");           // 指定した位置に挿入する
        s1.Replace("これを", "こっちに置換"); // 指定した文字を置換する
    }

    string Null()
    {
        return null;
    }

    /// <summary>
    /// 配列を使う
    /// </summary>
    string[] Array()
    {
        // ********** 定義 **********

        // []でアクセス
        string[] a1 = new string[3];
        a1[0] = "A";
        a1[1] = "B";
        a1[2] = "C";

        string[] a2 = { "A", "B", "C" };  // これでも定義可能

        // 配列の長さ
        int len = a1.Length;

        for (int i = 0; i < a1.Length; i++)
        {
            Dummy.Log(a1[i]);
        }


        // ********** 判定 **********

        int equalCount = 0;

        for (int i = 0; i < a1.Length; i++)
        {
            if (a1[i] == a2[i])
            {
                equalCount++;
            }
        }

        // 配列という入れ物は別物なので、falseになる点に注意！
        // (new string[] の new で新しい配列を作っているので別物)
        Dummy.Log(a1 == a2);

        return a1;
    }

    void ForEach(string[] array)
    {
        // ********** 配列を全部ループ **********

        foreach (string s in array)
        {
            Dummy.Log(s);
        }


        // ********** 配列を扱うメソッド **********

        // (配列 → 文字列) ","で結合
        string csv = string.Join(",", array);

        // (文字列 → 配列) ","で分割
        string[] split = csv.Split(',');

        // ','は一文字を表す (char型)
        char separator = ',';

        // 文字列(string)は、文字(char)の集まりなのでループ可能
        foreach (char c in csv)
        {
            if (c != separator)
            {
                Dummy.Log(c);
            }
        }

        for (var i = 0; i < csv.Length; i++)
        {
            // Substring()メソッドで1文字を取り出す必要はない
            csv.Substring(0, 1);
        }

        Dummy.Log(split.Length);


        // ********** Unityのメソッドで配列を受け取ってみる **********

        GameObject[] objects = GameObject.FindGameObjectsWithTag("GameController");

        foreach (var o in objects)
        {
            Dummy.Log(o.name);
        }
    }
}